.include "D:\Program Files\Atmel\AVR Studio\Appnotes\tn15def.inc"

;    .. 
;    ..

.DEF	Step=r20
.DEF	FreqIndex=r21
.DEF	FreqDelay=r22
.DEF	tmp=r27
.DEF	tmp2=r28
.DEF	tmp3=r26
.DEF	tmp4=r25

;  
.cseg
.org 0
;   tiny15
	rjmp	RESET
	nop		;rjmp  EXT_INT0	  
	nop		;rjmp  EXT_PIN	  
	nop		;rjmp  LOW_LEVEL
	nop		;rjmp  TIME_1	;   1
	rjmp  TIME_0 	;   0
	nop		;rjmp  EE_RDY   
	nop		;rjmp  ANA_COMP	  
	
;    
.org 20

Reset:	nop	
;    
	clr	tmp
	clr	tmp2
	clr	tmp3
	clr	tmp4
	clr FreqIndex
	clr	FreqDelay
;     B
	ldi	tmp2,$04
	out	DDRB,tmp2
;   0    
;    
	ldi	tmp3,$05
	out	TCCR0,tmp3 ;  /1024
	ldi	tmp3,$02
	out	TIMSK,tmp3 ;     0
;   1
	sei

;  1   
;      1:64
;       
	ldi	tmp4, $9B	;  #10011011

;   1    , 
;   ,
	out	TCCR1, tmp4	; 1   (1)

;     
	clr	Step
;  

ReadNote:						;      
	wdr	
	ldi	r31,High(2*ProgramTab)	; FreqIndex = Lo ProgramTab[Step]
	ldi	r30,Low(2*ProgramTab)	; FreqDelay = Hi ProgramTab[Step]
	mov	r0,Step                 ; Step++
	lsl	r0
	add	r30,r0
	inc	Step
	lpm
	mov	FreqIndex,r0
	inc	r30
	lpm
	cpi	Step, $16
	brne	dal
	rjmp	SleepReset		;  ,   
;   ,   
dal:	nop
	mov	FreqDelay,r0            

		
SetFreq:        ;   1     
	ldi	r31,High(2*SoundTab)	; OCR1A = SoundTab[FreqIndex]
	ldi	r30,Low(2*SoundTab)
	lsl	FreqIndex
        add	r30,FreqIndex
        lpm
        out	OCR1A,r0
	inc	r30
        lpm
       out	OCR1B,r0
;  
SetDalay:	nop
	ldi	r31,High(2*NoteDelay)
	ldi	r30,Low(2*NoteDelay)
	lpm
	mov	FreqDelay,r0  

; 	

Wait:	tst	FreqDelay	;    	
;   ,  
	brne	Wait		;  
;   0,    	
	rjmp	ReadNote	

SleepReset:
        ldi	r30,$3F		;      Power Down
        out	MCUCR,r30
	sleep			;  
	rjmp	Reset		;        
				;   
;   0,    
TIME_0:	nop
		dec	FreqDelay	
		clr	tmp4
		out	TCNT1, tmp4	;  1
		reti

.ORG	$100
SoundTab:
;    .
;      256 ,   ,
;     16- .
.DW 32047,32106,32095,32089,32084,32071,32063    ; 440  -  ""
.DW 32060,32053,32047,32045,32042,32036,32032      ;  
.DW 32030,32027,32024,32022,32021,32018,32016      ;  
;     .

.ORG	$140
ProgramTab:
;   ,
;  :  / ,   .
;      .
.DW	$1000, $1002, $1003, $1004, $1005, $1006, $1007
.DW	$1008, $1009, $100A, $100B, $100C, $100D, $100E
.DW	$200D, $200B, $2009, $2007, $2005, $2003, $2001
.DW	$8000

.ORG	$180
NoteDelay:
;   ,
.DW	$0064, $3200, $1003, $1004, $1005, $1006, $1007
.DW	$1008, $1009, $100A, $100B, $100C, $100D, $100E
.DW	$200D, $200B, $2009, $2007, $2005, $2003, $2001
.DW	$8000

.EXIT
